//=============================================================================
//
// file :         RPC2TangoBridgeClass.h
//
// description :  Include for the RPC2TangoBridgeClass root class.
//                This class is represents the singleton class for
//                the RPC2TangoBridge device class.
//                It contains all properties and methods which the 
//                RPC2TangoBridge requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author: giacomo $
//
// $Revision: 1.1.1.1 $
//
// $Log: RPC2TangoBridgeClass.h,v $
// Revision 1.1.1.1  2008-04-28 09:13:16  giacomo
// Prima versione di RPC2TangoBridge
//
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _RPCALARMTANGOCLASS_H
#define _RPCALARMTANGOCLASS_H

#include <tango.h>
#include <RPC2TangoBridge.h>


namespace RPC2TangoBridge_ns
{
//=====================================
//	Define classes for attributes
//=====================================
//=========================================
//	Define classes for commands
//=========================================
class OnClass : public Tango::Command
{
public:
	OnClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OnClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OnClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<RPC2TangoBridge *>(dev))->is_On_allowed(any);}
};



class StandbyClass : public Tango::Command
{
public:
	StandbyClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StandbyClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StandbyClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<RPC2TangoBridge *>(dev))->is_Standby_allowed(any);}
};



class RPCDataForAttributeCmd : public Tango::Command
{
public:
	RPCDataForAttributeCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	RPCDataForAttributeCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~RPCDataForAttributeCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<RPC2TangoBridge *>(dev))->is_RPCDataForAttribute_allowed(any);}
};



//
// The RPC2TangoBridgeClass singleton definition
//

class RPC2TangoBridgeClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static RPC2TangoBridgeClass *init(const char *);
	static RPC2TangoBridgeClass *instance();
	~RPC2TangoBridgeClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	RPC2TangoBridgeClass(string &);
	static RPC2TangoBridgeClass *_instance;
	void command_factory();
	void get_class_property();
	void write_class_property();
	void set_default_property();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace RPC2TangoBridge_ns

#endif // _RPC2TANGOBRIDGECLASS_H
