#include "RPCHandleSet.h"
namespace RPC2TangoBridge_ns
{

RPCHandleSet* RPCHandleSet::_instance = NULL;

RPCHandleSet::RPCHandleSet()
{
	
}

RPCHandleSet *RPCHandleSet::instance()
{
	if(_instance == NULL)
		_instance = new RPCHandleSet();
	return _instance;
}
	

RPCReadHandle *RPCHandleSet::readHandleFromList(const char *rpc_call)
{
	unsigned int i, res;
	RPCReadHandle *han;
	char *host;
	short int port;
	res = RPCHandle::resolve_rpc(rpc_call, &host, &port);
	if(host != NULL && res >= 0)
	{
		/* in host and port we have the host and port of the rpc service for that call */
		for(i = 0; i < rpcRHandles.size(); i++)
		{
			han = rpcRHandles[i];
			/* we must exclude the handles with host and port uninitialized */
			if(han != NULL && han->host() != "" && han->port() != 0 &&
					han->host() == string(host) && han->port() == port)
				return han;
		}
	}
	return NULL;
}

RPCWriteHandle *RPCHandleSet::writeHandleFromList(const char *rpc_call)
{
	unsigned int i, res;
	RPCWriteHandle *han;
	char *host;
	short int port;
	res = RPCHandle::resolve_rpc(rpc_call, &host, &port);
	if(host != NULL && res >= 0)
	{
		/* in host and port we have the host and port of the rpc service for that call */
		for(i = 0; i < rpcWHandles.size(); i++)
		{
			han = rpcWHandles[i];
			/* we must exclude the handles with host and port uninitialized */
			if(han != NULL && han->host() != "" && han->port() != 0 &&
					han->host() == string(host) && han->port() == port)
				return han;
		}
	}
	return NULL;
}

void RPCHandleSet::removeHandle(RPCHandle *h)
{
	unsigned int i;
	for(i = 0; i < rpcHandles.size(); i++)
	{
		if(rpcHandles[i] == h)
			break;
	}
	if(i < rpcHandles.size())
	{
		//printf(" - removing handle \"%s\":%d from list\n", rpcHandles[i]->host().c_str(), rpcHandles[i]->port());
		rpcHandles.erase(rpcHandles.begin() + i);
	}
	else{
		//printf("\e[1;31m *\e[0m error: handle  \"%s\":%d  not found in list!\n", rpcHandles[i]->host().c_str(), rpcHandles[i]->port());
	}
}

RPCHandle *RPCHandleSet::handleFromList(const char *rpc_call)
{
	unsigned int i, res;
	RPCHandle *han;
	char *host;
	short int port;
	res = RPCHandle::resolve_rpc(rpc_call, &host, &port);
	if(host != NULL && res >= 0)
	{
		/* in host and port we have the host and port of the rpc service for that call */
		for(i = 0; i < rpcHandles.size(); i++)
		{
			han = rpcHandles[i];
			/* we must exclude the handles with host and port uninitialized */
			if(han != NULL && han->host() != "" && han->port() != 0 &&
					han->host() == string(host) && han->port() == port)
				return han;
		}
	}
	return NULL;
}

void RPCHandleSet::addReadHandle(RPCReadHandle* h)
{
	rpcRHandles.push_back(h);
}

void RPCHandleSet::addWriteHandle(RPCWriteHandle* h)
{
	rpcWHandles.push_back(h);
}


}









