#ifndef RPC_HANDLE_H
#define RPC_HANDLE_H

#include <iostream>
#include <omnithread.h>
#include <tango.h>
#include <vector>
#include <lpc.h>

#define RPCSPLITLEN     32
#define MAXLEN 256

using namespace std;

namespace RPC2TangoBridge_ns
{
class RPCHandle/*: public Tango::LogAdapter*/
{
	public: 
		RPCHandle(string call);
		RPCHandle(RPCHandle *other);
		~RPCHandle();

		std::string host() { return _host; }
		unsigned short port() { return _port; }
		int sid() { return _sid; }

		bool connected(); 

		bool operator==(const  RPCHandle &other) const  
			{ return _host == other._host && _port == other._port; }
	
		bool lockRpc();
		bool unlockRpc();

		std::string lastRpcError() { return _lastRpcErr; } 
		
		static int split_rpccall(const char *call, char* fam, char *mem, char* act, char* mode);
		/* returns true if resolve takes place */
		static bool resolve_rpc(const char *call, char** host, short int *port);
		
		unsigned _refcnt;
		
	protected:
		std::string _lastRpcErr;
		int _sid;
		
	private:
		std::string _host;
		unsigned short _port;

		bool connect();


};



} /* namespace RPC2TangoBridge_ns ends */


#endif


