#ifndef RPC_READ_HANDLE_H
#define RPC_READ_HANDLE_H

#include <string>
#include <omnithread.h>
#include <RpcResolver.h>
#include "RpcHandle.h"
#include <errtype.h>

#define MAXERRLEN	512

namespace RPC2TangoBridge_ns
{
	
class RPCReadHandle : public RPCHandle
{
	public:
		RPCReadHandle(RPCHandle *h);
		
		idl_long_int read_long(const char *callname, int* ok);
		double read_double(const char *callname, int* ok);
		idl_short_int read_short(const char *callname, int* ok);
		unsigned char read_uchar(const char *callname, int* ok);
		unsigned char read_boolean(const char *callname, int* ok);
		string read_string(const char *callname, int* ok);

		intArray read_slong(const char *callname, int* ok);
		charArray read_schar(const char *callname, int* ok);
		realArray read_sdouble(const char *callname, int* ok);
		shortArray read_sshort(const char *callname, int* ok);
		booleanArray read_sboolean(const char *callname, int* ok);
	
};

}

#endif
