#include <tango.h>
#include <lpc.h>
#include <RPC2TangoBridge.h>
#include <BridgeAttr.h>
#include <RpcHandle.h>

using namespace Tango;
using namespace std;

namespace RPC2TangoBridge_ns
{

bool RPC2TangoBridge::write_dynamic_attribute(Tango::WAttribute &attr)
{
//  	 printf("\r                                                                    ");
//  	 fflush(stdout);
// 	 printf("\r                                                                  \r");
//  	 printf("\e[1;32m* \e[1;37mwriting \e[0m%s\e[0m\n", attr.get_name().c_str() );
//  	 fflush(stdout);

	DevLong dl;
	DevShort ds;
	DevDouble dd;
	DevBoolean db;
	long int l;
	double d;
	short s;
	string ress;
	bool b;

	/* search name in scalars map first */
 	map<string, BridgeAttr*>::iterator mapiter;
	mapiter = namesMap.find(attr.get_name());

	if(mapiter != namesMap.end())
 	{
		BridgeAttr *brattr = (*mapiter).second;
		if(brattr->get_writable() != Tango::READ_WRITE)
		{
			//printf("\e[1;31m*\e[0m error: writable is not READ_WRITE\n");
			return false;
		}
		fflush(stdout);
// 		printf("read_dynamic_attribute: name %s\n", brattr->writeName().c_str());
		RPCWriteHandle *rpch = brattr->rpcWriteHandle();
// 		printf("read_dynamic_attribute: name %s\n", brattr->writeName().c_str());
		if(rpch)
		{
			switch(brattr->get_type())
			{
				case Tango::DEV_LONG:
					attr.get_write_value(dl);
					l = (long) dl;
					return rpch->write_long(brattr->writeName().c_str(), l);

				case Tango::DEV_DOUBLE:
					attr.get_write_value(dd);
					d = (double) dd;
					return rpch->write_double(brattr->writeName().c_str(), d);
				
				case Tango::DEV_SHORT:
					attr.get_write_value(ds);
					s = (short) ds;
					return rpch->write_short(brattr->writeName().c_str(), s);
// 				case Tango::DEV_STRING:
// 					
				
				case Tango::DEV_BOOLEAN:
					attr.get_write_value(db);
					b = (bool) db;
					return  rpch->write_boolean(brattr->writeName().c_str(), b);
                                case Tango::DEV_VOID:
					attr.get_write_value(db);
					b = (bool) db; //dummy
					return  rpch->write_void(brattr->writeName().c_str());
				default:
					
					//printf("\t[\e[1;31mfailed\e[0m] (format not supported - %d)\n", brattr->get_type());
					Except::throw_exception("Error reading scalar attribute " + brattr->writeName(),
						"The format is not supported.\nSupported formats: long, double",
						"RPC2TangoBridge::read_BridgeAttr()");
					break;
			}

		}
		else{
			//printf("\e[1;31m*\e[0m error: rpc write handle not initialized\n");
		}
		
		
 	}
	return false;
}


} /* namespace ends here */


